<!--- 
The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"); you may not use this file except in compliance with the
License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is comprised of the PT Poll directory

The Initial Developer of the Original Code is
PaperThin, Inc. Copyright(C) 2015.
All Rights Reserved.

By downloading, modifying, distributing, using and/or accessing any files 
in this directory, you agree to the terms and conditions of the applicable 
end user license agreement.
--->
<!---
/* *************************************************************** */
Author:
	PaperThin Inc.
	M. Carroll
Name:
	poll_question_gallery_simple_form_rh.cfm
Element:
	Poll Question Gallery
ADF App:
	pt_poll
Version:
	1.0.0
History:
	2010-02-10 - MFC - Created
	2016-02-26 - DRM - Resource detection exit
--->

<!--- if this module loads resources, do it here.. --->
<cfscript>
	application.ptPoll.scripts.loadJQuery();
	application.ptPoll.scripts.loadJQueryField();
	application.ptPoll.scripts.loadJQueryBlockUI();
</cfscript>

<!--- ... then exit if all we're doing is detecting required resources --->
<cfif Request.RenderState.RenderMode EQ "getResources">
  <cfexit>
</cfif>


<cfscript>
	// Force RH not to be cached
	request.element.isStatic = 0;
	
	// Get the items
	items = attributes.elementInfo.elementData.propertyValues;
	
	qIDList = "";
	qItemID = "";
	
	// Unique Script ID
	qID = request.Site.IDMaster.getID();
</cfscript>

<!--- Check that we have values --->	
<cfif ArrayLen(items)>
	<cfscript>
		qData = application.ptPoll.pollQuestionDAO.get(items[1].Values.pollQuestionID);
		
application.ptPoll.utils.dodump(qData, "qData", false);
	</cfscript>
	
	<!--- Check that we have the question data --->
	<cfif ArrayLen(qData)>
		<cfoutput>
		
		<h3>Poll</h3>
		
		<cfloop from="1" to="#arrayLen(qData)#" index="qItem">
		
		<cfscript>
			qID = qData[qItem].PageID;
		
			// keep track of the question ids for results
			qItemID = qData[qItem].values.ID;
			qIDList = listAppend(qIDList, qItemID);
		</cfscript>
		
		<!--- // jQuery code to store the vote on submit --->
		<script type="text/javascript">
			jQuery(function(){
			
				// Submit the Poll On Click Action
				jQuery("input##submitPoll_#qID#").click( function(){
					alert("Submit! Form: #qID#");
					
					// loop through all of the fields and pass the questionID and the value
					jQuery(".question_#qID#").each(function(){
						
						// Get the selected value
						var selectedVal = jQuery(this).getValue();
						//console.log(selectedVal);
						
						if (selectedVal.length) 
						{
							var id = jQuery(this).attr("name");
							// Put up loading
							loadSaving_#qID#();
							// Submit the poll form 
							submitPoll_#qID#(selectedVal, id);
						}
					});
					
				});
				
			});
			
			// handle submitting the votes
			function submitPoll_#qID#(selVal, id)
			{
				// send ajax call to post the vote
				jQuery.post("#application.ADF.ajaxProxy#",
				{
					bean: "pollVoteController",
					method: "processVote",
					questionID: id,
					vote: selVal,
					userid: "#request.user.userid#"
				},
				function(msg){
					//alert("Vote Logged");
					loadStats_#qID#(id);
				});
			}
			
			// handle saving the function (adds effects)
			function loadSaving_#qID#()
			{
				jQuery("##submitPoll_#qID#").hide();
				jQuery("##viewResults_#qID#").hide();
				
				// Block the UI
				jQuery("##poll-question_#qID#").block({
					message: "<h3>Processing...</h3>",
					css: { border: "1px solid ##c0c0c0" }
				});
			}
			
			// after each post to vote - load that questions results
			function loadStats_#qID#(id)
			{
				jQuery.get("#application.ADF.ajaxProxy#",
				{
					bean: "pollVoteController",
					method: "voteStatsRender",
					questionID: id
				},
				function(msg){
					jQuery("##poll-votes_#qID#").html(msg);
					
					// UnBlock the UI
					jQuery("##poll-question_#qID#").unblock(); 
				});
			}
			
			// if they click the 'View Results' link
			function loadResults_#qID#(idList)
			{
				//var qIDArray = jQuery.ListToArray(idList);
				
				var qIDArray = idList.split(",");
				var i = 0;
				loadSaving_#qID#();
				for (i; i < qIDArray.length; i++) {
					loadStats_#qID#(qIDArray[i]);
				}
			}
		</script>

		<div id="poll-question_#qID#">
			
			<h4>#qData[qItem].values.question#</h4>
			
			<div id="poll-votes_#qID#">
			<!--- <div id="poll-votes_#qData[qItem].values.ID#"> --->
			
				<!--- // If needed, covert comma-delimited (",") list to pipe-delimited list ("|") --->
				<cfset voteOptionList = qData[qItem].values.voteOptions>
				<cfif ListLen(voteOptionList,",") GT 0>		
					<cfset voteOptionList = ListChangeDelims(voteOptionList,"|",",")>	 
				</cfif>
			
				<!--- // determine the question type --->
				<cfswitch expression="#qData[qItem].values.type#">
					<!--- // Selection List --->
					<cfcase value="Selection List">
						<p>
							<select name="#qData[qItem].values.ID#" id="#qData[qItem].values.ID#" class="question_#qID#">
								<option value="">- SELECT -</option>
								<cfloop list="#voteOptionList#" index="vote" delimiters ="|">
									<option value="#vote#">#vote#</option>
								</cfloop>
							</select>
						</p>
					</cfcase>
					<!--- // Radio Buttons --->
					<cfcase value="Radio Buttons">
						<!--- Loop over the options --->
						<cfset optCnt = 1>
						<cfloop list="#voteOptionList#" index="vote" delimiters="|">
							<p><input type="radio" name="#qData[qItem].values.ID#" id="#qData[qItem].values.ID#_#optCnt#" value="#Trim(vote)#" class="question_#qID#">#Trim(vote)#</p>
							<cfset optCnt = optCnt + 1>
						</cfloop>
					</cfcase>
				</cfswitch>
			</div>
		
			<p>&nbsp;</p>
			<p><input type="button" id="submitPoll_#qID#" name="submitPoll_#qID#" value="Submit Vote"></p>
			<p><a id="viewResults_#qID#" href="javascript:;" onclick="loadResults_#qID#('#qIDList#');">View Results</a></p>
		</div>
	</cfloop>
	</cfoutput>
	</cfif>
</cfif>